#
# spec file for package deepin-kwin
#
# Copyright (c) 2023 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#

%global kf5_version 5.90.0
%global qt5_version 5.15.0
%global wayland (0%{?suse_version} >= 1330)

Name:           deepin-kwin
Version:        5.25.26
Release:        1.7
# Full Plasma 5 version (e.g. 5.8.95)
%{!?_plasma5_bugfix: %define _plasma5_bugfix %{version}}
# Latest ABI-stable Plasma (e.g. 5.8 in KF5, but 5.8.95 in KUF)
%{!?_plasma5_version: %define _plasma5_version %(echo %{_plasma5_bugfix} | awk -F. '{print $1"."$2}')}
Summary:        Deepin Window Manager
License:        GPL-3.0-or-later
Group:          System/GUI/Deepin
Url:            https://github.com/linuxdeepin/deepin-kwin/
Source0:        https://github.com/linuxdeepin/deepin-kwin/archive/%{version}/%{name}-%{version}.tar.gz
# PATCH-FEATURE-OPENSUSE
Patch101:       0001-Export-consistent-hostname-as-XAUTHLOCALHOSTNAME.patch
BuildRequires:  extra-cmake-modules >= 0.0.11
BuildRequires:  fdupes
%if 0%{?suse_version} < 1550
BuildRequires:  gcc10-PIE
BuildRequires:  gcc10-c++
%endif
BuildRequires:  kf5-filesystem
BuildRequires:  libQt5Core-private-headers-devel >= %{qt5_version}
BuildRequires:  libQt5Gui-private-headers-devel >= %{qt5_version}
BuildRequires:  libQt5PlatformSupport-private-headers-devel >= %{qt5_version}
BuildRequires:  libcap-devel
BuildRequires:  libcap-progs
BuildRequires:  libepoxy-devel
BuildRequires:  hicolor-icon-theme
BuildRequires:  hwdata
BuildRequires:  pkgconfig
BuildRequires:  systemd-rpm-macros
BuildRequires:  xz
BuildRequires:  cmake(Breeze) >= 5.9.0
BuildRequires:  cmake(DWayland)
BuildRequires:  (cmake(KDecoration2) >= %{_plasma5_version} with cmake(KDecoration2) < 6)
BuildRequires:  cmake(KF5Activities) >= %{kf5_version}
BuildRequires:  cmake(KF5Completion) >= %{kf5_version}
BuildRequires:  cmake(KF5Config) >= %{kf5_version}
BuildRequires:  cmake(KF5ConfigWidgets) >= %{kf5_version}
BuildRequires:  cmake(KF5CoreAddons) >= %{kf5_version}
BuildRequires:  cmake(KF5Crash) >= %{kf5_version}
BuildRequires:  cmake(KF5DBusAddons) >= %{kf5_version}
BuildRequires:  cmake(KF5Declarative) >= %{kf5_version}
BuildRequires:  cmake(KF5DocTools) >= %{kf5_version}
BuildRequires:  cmake(KF5GlobalAccel) >= %{kf5_version}
BuildRequires:  cmake(KF5I18n) >= %{kf5_version}
BuildRequires:  cmake(KF5IconThemes) >= %{kf5_version}
BuildRequires:  cmake(KF5IdleTime) >= %{kf5_version}
BuildRequires:  cmake(KF5Init) >= %{kf5_version}
BuildRequires:  cmake(KF5KCMUtils) >= %{kf5_version}
BuildRequires:  cmake(KF5KIO) >= %{kf5_version}
BuildRequires:  cmake(KF5NewStuff) >= %{kf5_version}
BuildRequires:  cmake(KF5Notifications) >= %{kf5_version}
BuildRequires:  cmake(KF5Package) >= %{kf5_version}
BuildRequires:  cmake(KF5Plasma) >= %{kf5_version}
BuildRequires:  cmake(KF5Runner) >= %{kf5_version}
BuildRequires:  cmake(KF5Service) >= %{kf5_version}
BuildRequires:  cmake(KF5TextWidgets) >= %{kf5_version}
BuildRequires:  cmake(KF5Wayland) >= %{kf5_version}
BuildRequires:  cmake(KF5WidgetsAddons) >= %{kf5_version}
BuildRequires:  cmake(KF5WindowSystem) >= %{kf5_version}
BuildRequires:  cmake(KF5XmlGui) >= %{kf5_version}
BuildRequires:  (cmake(KScreenLocker) >= %{_plasma5_version} with cmake(KScreenLocker) < 6)
BuildRequires:  cmake(PlasmaWaylandProtocols)
BuildRequires:  cmake(QAccessibilityClient)
BuildRequires:  cmake(Qt5Concurrent) >= %{qt5_version}
BuildRequires:  cmake(Qt5Core) >= %{qt5_version}
BuildRequires:  cmake(Qt5DBus) >= %{qt5_version}
BuildRequires:  cmake(Qt5Quick) >= %{qt5_version}
BuildRequires:  cmake(Qt5QuickWidgets) >= %{qt5_version}
BuildRequires:  cmake(Qt5Script) >= %{qt5_version}
BuildRequires:  cmake(Qt5Sensors) >= %{qt5_version}
BuildRequires:  cmake(Qt5UiTools) >= %{qt5_version}
BuildRequires:  cmake(Qt5WaylandClient) >= %{qt5_version}
BuildRequires:  cmake(Qt5Widgets) >= %{qt5_version}
BuildRequires:  cmake(Qt5X11Extras) >= %{qt5_version}
BuildRequires:  pkgconfig(fontconfig)
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(ice)
BuildRequires:  pkgconfig(lcms2)
BuildRequires:  pkgconfig(libxcvt)
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(wayland-cursor) >= 1.2.0
BuildRequires:  pkgconfig(wayland-protocols)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(x11-xcb)
BuildRequires:  pkgconfig(xau)
BuildRequires:  pkgconfig(xcb) >= 1.10
BuildRequires:  pkgconfig(xcb-composite) >= 1.10
BuildRequires:  pkgconfig(xcb-cursor)
BuildRequires:  pkgconfig(xcb-damage) >= 1.10
BuildRequires:  pkgconfig(xcb-glx) >= 1.10
BuildRequires:  pkgconfig(xcb-icccm)
BuildRequires:  pkgconfig(xcb-image)
BuildRequires:  pkgconfig(xcb-keysyms)
BuildRequires:  pkgconfig(xcb-randr) >= 1.10
BuildRequires:  pkgconfig(xcb-render) >= 1.10
BuildRequires:  pkgconfig(xcb-shape) >= 1.10
BuildRequires:  pkgconfig(xcb-shm) >= 1.10
BuildRequires:  pkgconfig(xcb-sync) >= 1.10
BuildRequires:  pkgconfig(xcb-util)
BuildRequires:  pkgconfig(xcb-xfixes) >= 1.10
BuildRequires:  pkgconfig(xi)
BuildRequires:  pkgconfig(xkbcommon) >= 0.7.0
BuildRequires:  pkgconfig(xscrnsaver)
BuildRequires:  pkgconfig(xtst)
%if %{wayland}
BuildRequires:  pkgconfig(gbm)
BuildRequires:  pkgconfig(libdrm) >= 2.4.62
BuildRequires:  pkgconfig(libinput) >= 1.14
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(wayland-egl)
BuildRequires:  pkgconfig(xwayland)
# Don't use pkgconfig here as that would cause unresolvables on 0.1 -> 0.2 -> 0.3 bumps
BuildRequires:  pipewire-devel >= 0.3.29
# xorg-x11-server-wayland is required by plasma5-session-wayland and kwin5 can run with just X11
Recommends:     xorg-x11-server-wayland
%endif
# new default decoration
%if 0%{?suse_version} < 1600
Requires:       breeze5-decoration >= %{_plasma5_version}
%else
Requires:       breeze6-decoration
%endif
# Needed to show dialogs
Requires:       kdialog
# Needed for effects KCM at runtime
Requires:       libQt5Multimedia5
# Needed for the virtual desktop KCM
Requires:       kirigami2
Requires:       kitemmodels-imports
%requires_eq    libQt5Core5
%requires_eq    libQt5Gui5
Provides:       windowmanager
Provides:       deepin-kwin5
Provides:       qt5qmlimport(org.kde.kcms.kwinrules.1)
Provides:       qt5qmlimport(org.kde.kwin.2)
Provides:       qt5qmlimport(org.kde.kwin.3)
Provides:       qt5qmlimport(org.kde.kwin.private.overview.1)
Provides:       qt5qmlimport(org.kde.milou.0)
Provides:       qt5qmlimport(org.kde.private.kcms.kwin.effects.1)
# For post and verifyscript
Requires(post): permissions
Requires(verify):permissions
%requires_ge    Mesa-libEGL1
%requires_ge    libKF5WindowSystem5
%requires_ge    plasma-framework
# For displaying full monitor vendor names
Recommends:     hwdata

%description
deepin-kWin is the window manager of the Deepin desktop environment.

%package devel
Summary:        Development tools for deepin-kwin
Group:          Development/Libraries/C and C++
Requires:       %{name} = %{version}

%description devel
The deepin-kwin is the window manager of the Deepin desktop environment.
This package provides development files.

%lang_package

%prep
%autosetup -p1 -n %{name}-%{version}

%build
%if 0%{?suse_version} < 1550
  export CXX=g++-10
%endif
%cmake_kf5 -d build -- -DCMAKE_INSTALL_LOCALEDIR=%{_kf5_localedir} -DINCLUDE_INSTALL_DIR=%{_includedir}/%{name}
%cmake_build

%install
%kf5_makeinstall -C build
%if !%{wayland}
  rm %{buildroot}%{_kf5_bindir}/%{name}_wayland
%endif

sed -i 's#/usr/bin/env python3#/usr/bin/python3#' %{buildroot}%{_kf5_sharedir}/kconf_update/*.py

%kf5_find_lang
%kf5_find_htmldocs

%fdupes %{buildroot}%{_kf5_libdir}
%fdupes %{buildroot}%{_datadir}

%preun
%{systemd_user_preun %{name}_x11.service %{name}_wayland.service}

%post
/sbin/ldconfig
%if %{wayland}
%set_permissions %{_kf5_bindir}/%{name}_wayland
%endif
%{systemd_user_post %{name}_x11.service %{name}_wayland.service}

%postun
/sbin/ldconfig
%{systemd_user_postun %{name}_x11.service %{name}_wayland.service}

%files
%defattr(-,root,root,-)
%doc README.md README.zh_CN.md
# %license LICENSE
%dir %{_sysconfdir}/skel/.config
%config %{_sysconfdir}/skel/.config/kglobalshortcutsrc
%config %{_sysconfdir}/xdg/deepin-*
%config %{_sysconfdir}/xdg/kglobalshortcutsrc
%if %{wayland}
%verify(not caps) %{_kf5_bindir}/%{name}_wayland
%{_kf5_bindir}/%{name}_wayland_wrapper
%endif
%{_kf5_applicationsdir}/*.desktop
%{_kf5_bindir}/%{name}_x11
%{_kf5_debugdir}/org_kde_%{name}.categories
%{_kf5_knsrcfilesdir}/*.knsrc
%{_kf5_libdir}/kconf_update_bin/
%{_kf5_libdir}/lib%{name}*.so.*
%{_kf5_libdir}/libdeepin-kcmkwincommon.so.*
%{_kf5_plugindir}/%{name}
%{_kf5_plugindir}/kcms
%{_kf5_plugindir}/*.so
%dir %{_kf5_plugindir}/kpackage/
%dir %{_kf5_plugindir}/kpackage/packagestructure/
%{_kf5_plugindir}/kpackage/packagestructure/*.so
%dir %{_kf5_sharedir}/kpackage
%dir %{_kf5_sharedir}/kpackage/kcms
%{_kf5_sharedir}/kpackage/kcms/deepin-*
%{_kf5_plugindir}/org.kde.*
%{_libexecdir}/%{name}_*
%{_libexecdir}/%{name}-applywindowdecoration
%{_kf5_sharedir}/config.kcfg/
%{_kf5_sharedir}/%{name}
%{_kf5_sharedir}/icons/hicolor/*/apps/%{name}.*
%{_kf5_sharedir}/kconf_update/
%{_kf5_sharedir}/kservices5
%{_kf5_sharedir}/kservicetypes5
%{_kf5_sharedir}/knotifications5
%dir %{_datadir}/dsg
%dir %{_datadir}/dsg/configs
%dir %{_datadir}/dsg/configs/org.deepin.kwin
%{_datadir}/dsg/configs/org.deepin.kwin/org.deepin.kwin.splitmenu.display.json
%dir %{_kf5_sharedir}/krunner
%dir %{_kf5_sharedir}/krunner/dbusplugins
%{_kf5_sharedir}/krunner/dbusplugins/%{name}-runner-windows.desktop
%dir %{_kf5_qmldir}/org/
%dir %{_kf5_qmldir}/org/deepin
%dir %{_kf5_qmldir}/org/deepin/kwin
%dir %{_kf5_qmldir}/org/deepin/kwin/decoration
%{_kf5_qmldir}/org/deepin/kwin/decoration/*.qml
%{_kf5_qmldir}/org/deepin/kwin/decoration/libdecorationplugin.so
%{_kf5_qmldir}/org/deepin/kwin/decoration/qmldir
%dir %{_kf5_qmldir}/org/kde/
%{_kf5_qmldir}/org/kde/%{name}
#%{_userunitdir}/%{name}_wayland.service
#%{_userunitdir}/%{name}_x11.service

%dir %{_datadir}/doc/HTML
%dir %{_datadir}/doc/HTML/en
%dir %{_datadir}/doc/HTML/en/dcontrol
%{_datadir}/doc/HTML/en/dcontrol/*

%files lang -f %{name}.lang
%defattr(-,root,root,-)
%dir %{_datadir}/translations
%{_datadir}/translations/popupmenu

%files devel
%defattr(-,root,root,-)
%{_kf5_libdir}/lib%{name}*.so
%{_kf5_libdir}/cmake/DeepinKWinEffects
%{_kf5_libdir}/cmake/DeepinKWinDBusInterface
%{_includedir}/%{name}
%{_kf5_sharedir}/dbus-1/interfaces/

%changelog
* Fri May 24 2024 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.25.26
  * Fix bugs
* Fri Apr 26 2024 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.25.22
  * Fix bugs
* Mon Mar 18 2024 Hillwood Yang <hillwood@opensuse.org>
- Remove useless Requires
* Mon Mar 18 2024 Hillwood Yang <hillwood@opensuse.org>
- Don't limit breeze's version
* Tue Mar  5 2024 Hillwood Yang <hillwood@opensuse.org>
- Make sure to pick kdecoration and breeze < 6
* Thu Feb 22 2024 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.25.15
  * Fix bugs
* Fri Nov  3 2023 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.25.11
  * 3rd window title bar support HiDPI
  * Change titlebar height to 24px
  * Fix bugs
  * Remove unit files, they are useless for dde
* Sun Jun  4 2023 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.25.5
  * Allow window cropping on screen update
  * Set all windows 0 rounded corners by defaults
  * Remove some default shortcuts
  * Pick the best fillet
  * Fix bugs
* Tue Apr 18 2023 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.25.0
  * Merge dde-kwin and deepin-kwin
- Drop deepin-kwin-tabbox-chameleon-rename.patch, drop-nonexistent-translations.patch
  and fix-library-links.patch
- Add 0001-Export-consistent-hostname-as-XAUTHLOCALHOSTNAME.patch
* Tue Jan 17 2023 Hillwood Yang <hillwood@opensuse.org>
- Update fix-library-links.patch, fix build on new dtk
* Fri Oct 28 2022 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.5.24
  * Add split screen menu
  * Add decoration property interface
  * Add watermark feature and support super+s
  * Fix bugs
- Drop fix-build-on-5_25_3.patch
* Thu Sep  1 2022 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.5.11
  * Add the 'test-prj-running.sh' script
  * Add API to capture window data
  * Add API to record and shot screen
  * Add func about maxi button long press
  * Remove qt deps for windowtool
- Drop fix-build-on-5_18_6.patch, no longer support old kwin
- Add fix-build-on-5_25_3.patch instead of dde-kwin.5.4.26.patch
* Mon Jun 13 2022 Dominique Leuenberger <dimstar@opensuse.org>
- Drop cmake(KWaylandServer) BuildRequires: not actually needed and
  no longer existing.
* Fri Jun 10 2022 Hillwood Yang <hillwood@opensuse.org>
- Update version 5.4.26
  * update window raduis for effects
  * Add splitmenu translate
  * Add a dependency on 'kwin-wayland'
  * Add func about maxi button long press
  * Modify code based on code review results
  * Fix bugs
- Add dde-kwin.5.4.26.patch, fix build on kwin 5.24+
- Add drop-nonexistent-translations.patch
- No longer need kwayland-server (boo#1200318)
- Drop deepin-kwin-crash.patch
* Sat Feb 26 2022 Max Lin <mlin@suse.com>
- Fix Leap 15.4 build since Kwin has greater version than 5.21
  in Leap 15.4
* Fri Feb 25 2022 Hillwood Yang <hillwood@opensuse.org>
- Add fix-build-on-5_18_6.patch for leap
* Sun Feb 20 2022 Hillwood Yang <hillwood@opensuse.org>
- Update version 5.4.19
  * Frees heap memory when the program exits
  * Disable multitasking
  * disable effects by default
  * Support DDE Wayland
  * Support client activation from dde shell
  * Fix bugs
* Tue Nov 30 2021 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.4.12
  * Split screen mode is always grayed out in the working area
  * add split screen menu
  * support lightWeight config for shadow
  * optimize work thumbnail
  * Fix bugs
  * Workaround: builds are not performed under Kwin greater than 5.21
* Tue Nov  9 2021 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.3.14
  * Fix bugs
  * Update translations
* Wed Sep 22 2021 Hillwood Yang <hillwood@opensuse.org>
- Add fix-library-links.patch, fix build on Tumbleweed
* Tue Jun 15 2021 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.3.9
  * Fix bugs
  * Support kwin 5.21+, drop support-kwin-5_21+.patch
- Drop fix-crash-bug.patch, fixed by upstream
* Tue May  4 2021 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.3.7
  * Support kwin 5.19, drop support-kwin-5_19+.patch
  * Add translation files
  * update dde-kwin.postinst base on update DTK's /etc/os-version
  * Fix bugs
- Drop deepin-kwin-unload-blur.patch, merged by upstream
* Sun Apr 11 2021 Hillwood Yang <hillwood@opensuse.org>
- Support kwin 5.21+, add support-kwin-5_19+.patch and
  support-kwin-5_21+.patch
* Mon Mar  1 2021 Hillwood Yang <hillwood@opensuse.org>
- Update version to 5.2.0.13
  * fix: Avoid taskbar showing up when changing workspace in multitaskingview
  * Revert "fix: Provides a default wallpaper for the second workspace."
  * fix: mips platform second workspace background is white.
  * Provides a default wallpaper for the second workspace.
  * fix get sp1 default-uri method.
  * fix: A color field flicker when right-click menu show up
    Adjust the order of image processing
  * after system upgrading from SP1 to SP2, the old wallpaper will be kept.
  * Provides a default wallpaper for the second workspace.
  * remove dialog rule to avoid configuration by user
  * fix: Blur multitasking background.
- Add patches: deepin-kwin-crash.patch, deepin-kwin-tabbox-chameleon-rename.patch
  and deepin-kwin-unload-blur.patch
* Sat Mar 21 2020 Hillwood Yang <hillwood@opensuse.org>
- remove some files which are in plasma5-defaults-openSUSE
* Fri Jul 19 2019 Hillwood Yang <hillwood@opensuse.org>
- update version to 0.1.0
  * Allow configuration items to override the default theme
  * Add the "deepin-chameleon" window decoration for kwin
  * Support get the shoutcut default value
  * Correct the path to find translation files
  * Ignore the RuleBook::save function of kwin
  * Execute dirname before setting the LD_PRELOAD environment
  * Support KWin highlightWindows effect for PreviewWindow
  * Overwrite the window menu
  * Support for specifying the version of kwin on build
  * Multitaskingview: add multitaskingview ts
  * Automatically append the wallpaper's gsetting value item
  * Clean LD_PRELOAD env
  * Fix the window was closed incorrectly
  * Fix the "Window to Desktop" shoutcuts is invalid
  * Fix No warning when opening the multitasking view app in 2D window manager
  * Fix do not print warning messages when the build and runtime versions are consistent
  * keep window to viewable if it is minimized
  * Disable theme cache of FrameSvg
  * Install the "kdeglobals" file
  * Fix the compositingEnabledChanged signal is sent only when the user actively sets it
  * Fix the window default cursor of the gtk application does not follow the theme
  * Disable window manager window menu
  * Preview window give priority to use the dbus interface by kwin
  * Support PresentWindows
  * Support set cursor theme/size for kwin
* Wed May  8 2019 Hillwood Yang <hillwood@opensuse.org>
- Initial package for version 0.0.5
